#if !defined(HWE__INCLUDED_)
#define HWE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000




#define	HWEHANDLE HANDLE

#if defined(_WIN64)
#define NativeInt INT64
#define NativeUInt UINT64
#define	HWEAPI 
#else
#define NativeInt int 
#define NativeUInt unsigned int
#define	HWEAPI __stdcall
#endif



#define	HWEBOOL unsigned int

// Return statuses of the write layer (return values of Hwe_Init or return value of Hwe_GetLayerStatus)
#define	HWE_OK 0
#define	HWE_ACCESS_LAYER_CANT_CONNECT 1
#define	HWE_NO_DVD_WRITERS 2


// Return values of Hwe_GetMediaStatus
#define HWE_NO_SELECTED_DRIVE -1      // No selected writers available
#define HWE_READY_TO_WRITE 0          // Empty DVD (re)writable Media is inserted - Write can start
#define HWE_FULL_RW 1                 // Full rewritable DVD - write can start, but existing data on DVD will be lost
#define HWE_NOT_READY 2               // Drive is not ready (no media detected)
#define HWE_MEDIA_NOT_WRITABLE 3      // Detected media is full and can''t be erased
// Removed 2008-04-14 #define HWE_NO_DVD_MEDIA 4            // Detected media is NOT a writable dvd media
#define HWE_NO_SUITABLE_MEDIA 4            // Detected media is NOT suitable for the kind of writing session


//Return values of Hwe_GetWriteStatus
#define HWS_INITOK 0                  // Write init ok - write process has started
#define HWS_NOFILES 1                 // Passed folder contained no files
#define HWS_MISSINGIFOORBUP 2         // IFO / BUP are missing
#define HWS_BADIFO 3                  // IFO contains invalid data. Will not work on some dvd players
#define HWS_CANTCHECKIFO 4            // Access to files can't be gained
#define HWS_TOOBIG 5                  // Files are too big to fit on a DVD+/-R(W)
#define HWS_BADMEDIASTATUS 6          // Media is not ready to be written (see above)
#define HWS_BLANKMEDIAFAILED 7        // Erasing a RW media has failed
#define HWS_NOMORESPACEFORTEMPFILE 8  // There is not enough space in temp folder to setup the temp file
#define HWS_CANTBUILDIMAGE 9          // Image can''t be built - lot of cause, including impossibility to create a temp file. in temp folder
#define HWS_FORMATFAILED 10           // Formatting media has failed
#define HWS_DEVICEBUSY 11             // Device is busy
#define HWS_DEVICEINITFAILED 12       // initialization of the writing device has failed
#define HWS_STARTBUFFERFAILED 13      // Failed to start the data buffering. Probably a windows out of memory
#define HWS_BADMEDIA 14               // Media is bad
#define HWS_FINALIZATIONFAILED 15     // Finalization process has failed
#define HWS_WRITINGFAILED 16          // Writing failed (write error or process aborted)
#define HWS_WRITINGCOMPLETE 17        // Write is complete
#define HWS_KEYCHECK 18               // Unlock key check has failed (passed unlock key is invalid or disactivated)
#define HWS_FORMATCOMPLETE 19         // Format media is complete
#define HWS_UNSUPPORTED 20            // Unsupported write method (denotes a media that cannot be written by the drive)
#define HWS_INVALIDISOPATH 21         // Invalid path for ISO creation

   // Extended write failure
#define HWS_USER_ABORT 21             // User has requested to stop the write sequence
#define HWS_FAILED_CALIBRATING 22     // Write failed at the beginning of the media (often a media that is poorly supported by the drive)
#define HWS_FAILED_FINISHING 23       // Write failed at the end of the media (finalisation is not complete
#define HWS_WRITING 24            	  // Currently Writing now


// Return values of Hwe_GetMediaType
#define MEDIA_UNKNOWN     0x0000   // No Media
#define MEDIA_NRDISC      0x0001   // Non removable disc
#define MEDIA_RMDISC      0x0002   // Removable Disc
#define MEDIA_MOE         0x0003   // Magneto Optical Erasable
#define MEDIA_OPTICWO     0x0004   // Optical Write Once
#define MEDIA_ASMO        0x0005   // Advanced Storage - Magneto Optical
#define MEDIA_CDROM       0x0008   // CD-ROM (not writable)
#define MEDIA_CDR         0x0009   // CD-R (Write once)
#define MEDIA_CDRW        0x000A   // CD-RW (R/W)
#define MEDIA_DVDROM      0x0010   // DVD-ROM (not writable)
#define MEDIA_DVDR        0x0011   // DVD-R
#define MEDIA_DVDRAM      0x0012   // DVD-RAM
#define MEDIA_DVDRW       0x0013   // DVD-RW Restricted overwrite
#define MEDIA_DVDRWSEQ    0x0014   // DVD-RW Sequential Recording
#define MEDIA_DLDVDR      0x0015   // Dual Layer DVD-R
#define MEDIA_DLDVDRJMP   0x0016   // Dual Layer DVD-R Jump Recording
#define MEDIA_DVDPLUSRW   0x001A   // DVD+RW
#define MEDIA_DVDPLUSR    0x001B   // DVD+R
#define MEDIA_DDCDROM     0x0020   // Double Density CD-ROM
#define MEDIA_DDCDR       0x0021   // Double Density CD-R (Write once)
#define MEDIA_DDCDRW      0x0022   // Double Density CD-RW
#define MEDIA_DLDVDPLUSRW 0x002A   // Dual Layer DVD+RW
#define MEDIA_DLDVDPLUSR  0x002B   // Dual Layer DVD+R
#define MEDIA_BDROM       0x0040   // BluRay Disc ROM (not writable)
#define MEDIA_BDR         0x0041   // BluRay Disc Sequential Recording
#define MEDIA_BDRE        0x0042   // BluRay Disc Random Recording

#define MEDIA_HDBURNCDROM 0x0080   // HDBurn CD-R
#define MEDIA_HDBURNCDR   0x0081   // HDBurn CD-R
#define MEDIA_HDBURNCDRW  0x0082   // HDBurn CD-RW

#define MEDIA_NODEVICE    0xFFFE
#define MEDIA_CUSTOM      0xFFFF   // doesn't conform to any standard media



// Current write operation passed in the Hwe_ApiCallback proc

#define WRO_BROWSEFILES 0		     // Deprecated - do not use
#define WRO_COPYDATATOCACHE 1        // Deprecated - do not use
#define WRO_NEWMEDIAINSERTED 2       // Deprecated - do not use
#define WRO_MEDIAREMOVED 3		     // Deprecated - do not use
#define WRO_NUMBEROFDEVICECHANGED 11 // Deprecated - do not use

#define WRO_BROWSE_FILES 0		     // Write engine is browsing files, progress = 0
#define WRO_COPY_DATA_TO_CACHE 1     // Data is currently copied to cache file, progress = progression of the cache operation - 0 to 0xFFFF
#define WRO_DISC_ACCEPTED 2          // New media has been inserted, progress = media change counter
#define WRO_DISC_REJECTED 3		     // Media has been removed, progress = media change counter
#define WRO_ERASING 4			     // Media erasure is in progress, progress = progression of the erase operation - 0 to 0xFFFF
#define WRO_FORMATTING 5		     // Media formatting is in progress, progress = progression of the format operation - 0 to 0xFFFF
#define WRO_WRITING 7 			     // Media write is in progress, progress = progression of the write operation - 0 to 0xFFFF
#define WRO_FINISIHING 8		     // Media finalization is in progress, progress = progression of the finalize operation - 0 to 0xFFFF
#define WRO_FINISHED 9			     // Write has finished, progress = Write status (same has Hwe_GetWriteStatus)
#define WRO_LOG 10				     // A log event has occured. progress is a pointer on the szChar
#define WRO_DEVICE_COUNT_CHANGED 11  // A Device (drive) has been added or removed
#define WRO_PARSING_DISC 12          // Disc is being parsed

// FOR WRO_LOG, the memory allocated in the string passed in Progress will be freed as soon as the callback will return.
// So DO NOT USE directly the pointer as is, copy the string instead


// Added 2004/10/13 - J. Vignoles
// Drive status as returned by Hwe_GetDriveStatus
#define DRIVESTATUS_READY    0     // Disc is loaded in the drive and drive is ready
#define DRIVESTATUS_NODISC   1     // No disc is loaded in the drive and tray is closed.
#define DRIVESTATUS_NOTREADY 2     // Drive is not ready. Disc loading may be in progress.
#define DRIVESTATUS_TRAYOPEN 3     // Tray is opened
#define DRIVESTATUS_INUSE    4     // Drive is currently in use by another Patin-couffin App.
#define DRIVESTATUS_NOTFOUND 5     // There is no drive found matching the DOS letter passed
#define DRIVESTATUS_UNKNOWN  10    // Disc status is unknown.

// Added 2007/08/31 - J. Vignoles
// Give more possibilities about DAO/TAO (PACKET) writing mode on DVD-R
#define HWE_WRITE_AFFINITY_AUTOMATIC 0        // Let the engine detect automatically which writing mode is more suitable
                                              // The decision is done according to:
                                              // * If the source is mono-session, or if trying to burn a ISO image, DAO is tried first.
                                              // * If the source is multi-session or there is existing data on DVD, TAO is tried first.
                                              // * for each burning mode, there is a BLACKLIST of drives that doesn't support one or the other mode
                                              //   if such drive is encountered, the supported mode is forced
                                              // * if DAO has to be used with a multisession source, it'll turn multisession off while issuing a warning about it.
                                              //   if data already exist on a DVD-R in multisession, TAO mode is always forced, and DAO will not even be tried.

    // For all the following modes, If DAO is attempted and multimedia mode is on, it is turned off and a warning is issued
#define HWE_WRITE_AFFINITY_FORCE_DAO 1        // Override all aforementionned logic to force DAO writing mode, if DAO fail to initialize, burning will fail
#define HWE_WRITE_AFFINITY_FORCE_TAO 2        // Override all aforementionned logic to force TAO writing mode, if TAO fail to initialize, burning will fail
#define HWE_WRITE_AFFINITY_PREFER_DAO 3       // prefer DAO writing mode, if DAO fail to initialize, log failure and try TAO
#define HWE_WRITE_AFFINITY_PREFER_TAO 4       // prefer TAO writing mode, if TAO fail to initialize, log failure and try DAO


// Added 2009/08/10 - disc rejection reason passed in Progess field within WRO_DISC_REJECTED message
#define DRR_UNKNOWN                              0  // Disc rejected for unknown reason
#define DRR_DISC_NOT_EMTPY						 1  // Inserted disc is not empty and not (re)writable
#define DRR_DISC_NOT_READABLE					 2  // Inserted disc cannot be read (unknown cause)
#define DRR_PARSING_INTERRUPTED_NO_DISC			 3  // No disc detected in drive, and parsing operation was interrupted by user.
#define DRR_PARSING_INTERRUPTED_TRAY_OPENED		 4  // Device's Tray was opened interrupting the parsing operation
#define DRR_NO_DISC								 5  // No disc detected in drive (there's nothing loaded in the drive)
#define DRR_NO_DISC_TRAY_OPENED					 6  // No disc detected in drive and Tray is opening/opened
#define DRR_INCOMPATIBLE_DISC					 7  // Disc is not compatible with the drive (ex. a DVD inserted in a CD-Rom only reader)
#define DRR_INCOMPATIBLE_WRITE					 8  // Disc is compatible with the drive but cannot be written (ex. a DVD+RW with a writing speed that doesn't support the drive)
#define DRR_HARDWARE_FAILURE					 9  // Drive has reported an hardware failure while parsing disc. This denotes a poor disc or a drive issue
#define DRR_WRONG_DISC_TYPE						10  // Disc type isn't correct (ex: inserting a CD-R when you need to write a DVD-VIDEO)



/*
	Callback function that the API call to notify a status changing or a progress in current operation
*/
typedef void (HWEAPI *PFNHwe_ApiCallback)(const HWEHANDLE H, unsigned int WriteOp, NativeUInt Progress, void *UserParam);

/*
	Initialize the burning engine. During this call, the available drives are enumerated
	* Must be called from main app thread context

*/
typedef int (HWEAPI *PFNHwe_Init)(const char *Path, const HWEHANDLE WndH, HWEHANDLE *H);

/*
	Free the burning engine
*/
typedef void (HWEAPI *PFNHwe_Free)(const HWEHANDLE H);

/*
	Register the callback function
*/
typedef void (HWEAPI *PFNHwe_RegisterCallback)(const HWEHANDLE H,
										   PFNHwe_ApiCallback CallbackProc,
										   void *UserParam);

/*
	Send the SDK client key. The key sent here must be activated with an internet connection,
	the activation process is fully automatic, silent and transparent - activation is done only once on each computer
	* Must be called from main app thread context
*/
typedef HWEBOOL (HWEAPI *PFNHwe_SendKey)(const HWEHANDLE H, void *KeyRecord, int KeyRecordLength);

/*
	If you do not send the key with Hwe_SendKey, a nag screen will pop just before writing.
	This function allow you to customize the nag so it'll display information suitable for your business
*/
typedef void (HWEAPI *PFNHwe_CustomizeTrialDialog)(const char *szFormTitle, const char *szFormText, const char *szLinkText, const char *szLink, const char *szButtonText);

/*
	return the number of WRITERS (cd only writers are included - unlike what the function's name say)
*/
typedef unsigned int (HWEAPI *PFNHwe_GetDvdWritersCount)(const HWEHANDLE H);

/*
	return the number of DVD READERS. CD-only readers are not included
*/
typedef unsigned int (HWEAPI *PFNHwe_GetDvdReadersCount)(const HWEHANDLE H);

/*
	Given its zero based index (in dwIndex), return the writer's friendly name string. Recommended dwSize is 256 - typical size is 48
*/
typedef unsigned int (HWEAPI *PFNHwe_GetDvdWriterName)(const HWEHANDLE H, int dwIndex, char *szName, unsigned int dwSize);

/*
	Given the uppercase DOS device letter (in DosLetter), return the device's friendly name string - if the device is a	 CD/DVD unit.
	Recommended dwSize is 256 - typical size is 48. the return value is the required size of the string
*/
typedef unsigned int (HWEAPI *PFNHwe_GetDeviceName)(const HWEHANDLE H, char DosLetter, char *szName, unsigned int dwSize);

/*
	Given its zero based index (in dwIndex), Set the writing device (writer) to use
*/
typedef HWEBOOL (HWEAPI *PFNHwe_SetWriter)(const HWEHANDLE H, int dwIndex);

/*
	Set the creation of the log file - for debugging/reporting purpose
	* Must be called from main app thread context
*/
typedef void (HWEAPI *PFNHwe_SetLogFile)(const HWEHANDLE H, char* szLogFilePath);

/*
	return the burning layer init status, see above for possible values
*/
typedef int (HWEAPI *PFNHwe_GetLayerStatus)(const HWEHANDLE H);

/*
	return the media status (write readiness) of the currently selected drive, see above for possible values
*/
typedef int (HWEAPI *PFNHwe_GetMediaStatus)(const HWEHANDLE H);

/*
	return the current write operation, see above for possible values
*/
typedef int (HWEAPI *PFNHwe_GetWriteStatus)(const HWEHANDLE H);

/*
	return the media type of the inserted media in the selected writer, see above for possible values
*/
typedef int (HWEAPI *PFNHwe_GetMediaType)(const HWEHANDLE H);

/*
	return in number of sectors the absolute maximum size of the inserted media in the selected writer,
	no matter the media is full or empty.
*/
typedef unsigned int (HWEAPI *PFNHwe_EmptyMediaSize)(const HWEHANDLE H);

/*
	Start writing from folder szDvdPath, with the volume name szVolumeName, with VIDEO DVD formatting.
	* SzDvdPath may point to direct folder of VIDEO_TS folder. If VIDEO_TS and AUDIO_TS folders doesn't exist,
	  they are automatically created by the engine
	* IFO files are checked for consistency and fixed if necessary (see also Hwe_SetCheckAndFixIfo Below).
	* DVD structure and presence of specific DVD files is checked
	* This function is asynchronous (will return immediately). progress, error or success are reported through the registered callback.
	* Can be called safely from any thread context

*/
typedef void (HWEAPI *PFNHwe_StartWriting)(const HWEHANDLE H,
										char *szDvdPath,
										char *szVolumeName);


/*
	Start writing from folder szDvdPath, with the volume name szVolumeName, with DATA formatting.
	* Filesystem used is ISO/JOLIET (not compatible with VIDEO DVD)
	* This function is asynchronous (will return immediately). progress, error or success are reported through the registered callback
	* Can be called safely from any thread context

*/
typedef void (HWEAPI *PFNHwe_StartDataWriting)(const HWEHANDLE H,
										char *szDvdPath,
										char *szVolumeName);





/*
	Signal the burning engine to abort the current write operation, this is an asynchronous function, can be called from any thread context
*/
typedef void (HWEAPI *PFNHwe_AbortWrite)(const HWEHANDLE H);

/*
	Close the tray of the selected drive
*/
typedef HWEBOOL (HWEAPI *PFNHwe_CloseTray)(const HWEHANDLE H);

/*
	Open the tray of the selected drive
*/
typedef HWEBOOL (HWEAPI *PFNHwe_OpenTray)(const HWEHANDLE H);

/*
	Set media type to DVD-ROM - to improve hifi dvd readers compatability with some DVD+R/RW media
	CAUTION: This feature can turn some drives into ZOMBIE
*/
typedef HWEBOOL (HWEAPI *PFNHwe_SetMediaToRom)(const HWEHANDLE H, HWEBOOL ToRom);

/*
	Get the writer mode for +R or +RW media - will return if the drive produces DVD-ROM (return NOT NULL) or DVD+R(W) media (return NULL)
*/
typedef unsigned int (HWEAPI *PFNHwe_GetWriterMode)(const HWEHANDLE H, HWEBOOL PlusRW);

/*
	Set the writer mode for +R or +RW media - will return if the drive produces DVD-ROM or DVD+R(W) media
*/
typedef HWEBOOL (HWEAPI *PFNHwe_SetWriterMode)(const HWEHANDLE H, HWEBOOL PlusRW, HWEBOOL ToRom);


/*
	return the drive status (presence / availability of the drive / media) of the given drive, selected by its DOS drive letter
	See above for all possible values
*/
typedef int (HWEAPI *PFNHwe_GetDriveStatus)(const HWEHANDLE H, char DriveLetter);

// Added 14/01/05 - J. Vignoles
/*
	Given its DOS drive letter, Set the writing device (writer) to use
*/
typedef HWEBOOL (HWEAPI *PFNHwe_SetWriterBydosDevice)(const HWEHANDLE H, char DriveLetter);

/*
	return the DOS letter of a given drive (writing device)
*/

typedef char (HWEAPI *PFNHwe_GetWriterDosDevice)(const HWEHANDLE H, int dwIndex);

/*
	get the media volume name if there is a non-blank media inserted in the currently selected drive
	the return value is the required size of the string
*/
typedef int (HWEAPI *PFNHwe_GetMediaVolumeName)(const HWEHANDLE H, char *szName, unsigned int dwSize);

/*
	Lock the selected drive tray (the open button on the drive will be disabled).
	Return TRUE if success
*/
typedef HWEBOOL (HWEAPI *PFNHwe_LockTray)(const HWEHANDLE H);

/*
	UnLock the selected drive tray (the open button on the drive will be enabled).
	Return TRUE if success
*/
typedef HWEBOOL (HWEAPI *PFNHwe_UnlockTray)(const HWEHANDLE H);


// Added 2005-01-14 - in dll version 1.8.8.167 or above
/*
	Get the status of the IFO checking/fixing for DVD VIDEO creation mode.
	IFO checking consist in re-compute all the titlesets size assuming all the titlesets will constitute a single, continuous and gapless data stream
	Also a few tables and common allocation errors are checked and fixed if possible
*/

typedef HWEBOOL (HWEAPI *PFNHwe_GetCheckAndFixIfo)(const HWEHANDLE H);

/*
	turn on/off  the IFO checking/fixing for DVD VIDEO creation mode.
*/

typedef void (HWEAPI *PFNHwe_SetCheckAndFixIfo)(const HWEHANDLE H, HWEBOOL Value);


// Added 2005-01-17 - in DLL version 1.8.9.170 or above
/*
	This function return all the possible writing speed for the selected drive, and the inserted media
	* a valid speed is defined by a nonzero value in the speedlist table.
	* speed is returned in Kilobytes per second, average x1 for DVD is between 1352 and 1385 kbps (may depend on writing device), average x1 for CD is 176.4
	* first entry should be the RECOMMENDED value, based on the media inserted (if the device support it).
	* after first entry (recommended speed), all the other entries should be returned is DESCENDING speed order
	* a maximum of 50 speeds can be returned.

  see the mfc sample application for the usage of this function

*/
typedef HWEBOOL (HWEAPI *PFNHwe_GetWriteSpeeds)(const HWEHANDLE H, int *speedlist, int entrycount);

/*
	this function set the required write speed - THE EFFECTIVE WRITING SPEED MAY BE DIFFERENT,
	as the burner may force a speed he think more suitable for the media. The effective writing speed is often less than the required speed.

	 To set reliabily the writing speed, "speed" parameter must take the value of one of the speed entries returned by Hwe_GetWriteSpeeds

 */
typedef HWEBOOL (HWEAPI *PFNHwe_SetWriteSpeed)(const HWEHANDLE H, int speed);

/*
	this function allow to write a pre-built ISO image
	* szIsoPath contains the full path name of the ISO image.
	* This function is asynchronous (will return immediately). progress, error or success are reported through the registered callback
	* Can be called safely from any thread context

*/

typedef void (HWEAPI *PFNHwe_StartIsoWriting)(const HWEHANDLE H, char *szIsoPath);


// Added 2005-02-10- in DLL version 1.9.2.176 or above

typedef HWEBOOL (HWEAPI *PFNHwe_GetEnablePolling)(const HWEHANDLE H);

typedef void (HWEAPI *PFNHwe_SetEnablePolling)(const HWEHANDLE H, const  HWEBOOL poll);

// Added 2005-03-22 - in DLL version 1.9.5.184 or above
/*
	Start writing from a stream. You provide a pointer to a structure that will describe the context
	*
	* This function is asynchronous (will return immediately). progress, error or success are reported through the registered callback
	* Can be called safely from any thread context

*/

/* The calllback function prototype to provide data to the burning layer */
#define ReadDataProc(_x_) void(__stdcall *_x_)(void* Opaque, void* Data, int SectorCount, int SectorIndex, unsigned char *Final)

#pragma pack(push,1)						// Byte alignment. However, all the struct members have size multiple of 4
#pragma warning (disable : 4200)			// Structures with variable-size arrays
__declspec(deprecated)
typedef struct _THweInputStreamContext {
	/* Used when calling ReadDataProc - pass whatever you need, typically a pointer to any object */
	void *Opaque;
	/* Number of sectors to be written on the media. Each sector makes 2K */
	int SectorsToWrite;
	/* Address of the callback. Can be NULL, in that case data written is all 00 */
	ReadDataProc(ReadFunc);
	/* Timing of the write can be logged, for reporting purpose. If this value is set to FALSE, all the members below are reserved and can be set to 0 */
    ULONG bLogWriteTiming;
	/* Critical section protecting the read/write of the TimeTable  - must be initialized if bLogWriteTiming equals TRUE */
    RTL_CRITICAL_SECTION CsH;
	/* IN - Reserved (0), OUT - the number of ticks per seconds (to convert TimeTable values in Time) */
	LARGE_INTEGER PerfFreq;
	/* IN - Reserved (0), OUT - the number of sectors that represent the distance between two points of mesure */
    int BlockSize;
	/* IN - The number of point of mesures you want to issue throughout the whole burning process. The maximum value is (SectorsToWrite / 32).
	   Small value will reduce the accuracy of the timing chart, Big value will introduce jitter
	   A reasonnable value is from 500 to 2000. */
	int PointCount;
	/* OUT -  initialized to -1 then During the burning sequence, tell you the last point (0 based) that has been written.
	   CurrentPoint will range from -1 to (PointCount -1) */
	int CurrentPoint;
	/* OUT - MODIFIED 23 June 2008 : Pointer on the TimeTable.
	 TimeTable is a table of size (PointCount * LARGE_INTEGER) THAT MUST BE ALLOCATED BY THE CALLER
	 During burn sequence, this table will contains the time (in clock Tick) at burning completion of each block.
	 Any live use of this TimeTable pointer must be embedded into a EnterCriticalSection / LeaveCriticalSection,
	 to ensure a static content of the whole structure.
	*/
    LARGE_INTEGER *TimeTable;
} THweInputStreamContext, *PHweInputStreamContext;
#pragma pack (pop)

/* THweInputStreamContext struct if dynamically allocated must NOT be freed before the end of the burning sequence. */
/* Deprecated: Use PFNHwe_StartBinaryWriting in SDK V6.0.0.0 or above */
// __declspec(deprecated) typedef void (HWEAPI *PFNHwe_StartStreamWriting)(const HWEHANDLE H, PHweInputStreamContext sc);


// Added 2005-05-30 - - in DLL version 2.0.0.197 or above

/*
 Given its zero based index (in dwIndex), return TRUE or FALSE based on whether of not the device supports writing to dual layer media
 Note: does not require blank media in the drive
*/
typedef HWEBOOL (HWEAPI *PFNHwe_GetDualLayerWriteCapability)(const HWEHANDLE H, int dwIndex);


// Added 2005-06-22 - in DLL version 2.0.0.215 or above

// Global boolean to control if the burning engine send burn report to VSO when the burn sequence has completed.
// These informations are totally anonymous and used only of statistical purpose, to determine success rate of any given media on a given writer.
// Turning this feature on will require an internet connection active
typedef HWEBOOL (HWEAPI *PFNHwe_GetSendWebStats)(const HWEHANDLE H);

typedef void (HWEAPI *PFNHwe_SetSendWebStats)(const HWEHANDLE H, const  HWEBOOL SendStats);

// Added 2005-06-29 - in DLL version 2.0.0.216 or above
/*
	Blank the Media
	*
	* This function is asynchronous (will return immediately). progress, error or success are reported through the registered callback
	* Can be called safely from any thread context
	*
	* if EjectOnSuccess is true, the media is ejected if blank operation is a success
	* if EjectOnFail is true, the media is ejected if blank operation has failed
*/
typedef void (HWEAPI *PFNHwe_Blank)(const HWEHANDLE H, const  HWEBOOL EjectOnSuccess, const  HWEBOOL EjectOnFail);

// Added 2005-08-30 - In DLL version 2.0.4.232 or above

/*

 give a string containing the type name of all the supported media by the selected writer
 all the possible media type names are:
	"DVD-R"			//  DVD-R
	"DVD-RW Seq."	//  DVD-RW Sequential writing
	"DVD-RW RO"		//  DVD-RW Restricted Overwrite
	"DVDRAM"		//  DVD-RAM
	"DVD+R"			//	DVD+R
	"DVD+RW"		//	DVD+RW Rewritable
	"CD-R"			//	CD-R
	"CD-RW"			//	CD-RW Rewritable
	"DDCD-R"		//  Double Density CD-R (Sony)
	"DDCD-RW"		//	Double Density CD-RW Rewritable
	"HDB CD-R"		//	High Density Burn CD-R (Nec)
	"HDB CD-RW"		//  High Density Burn CD-RW Rewritable
	"DL DVD+R"		//  Double Layer DVD+R
	"DL DVD-R"		//  Double Layer DVD-R
	"Blu Ray-R"		//  Blue Ray DVD-R
	"Blu Ray-RE"	//  Blue Ray DVD-RE Rewritable

 each entry is separated by a ", " (a comma + a space)
 szName point to the string to fill (can be NULL)
 dwSize tell the buffer length of the string (can be = 0)
 The return value is the number of bytes required for the string (not counting the trailing '\0')

*/
typedef int (HWEAPI *PFNHwe_GetWriterSupportedMediaList)(const HWEHANDLE H, char *szName, unsigned int dwSize);

/*
  return if the selected writer is capable of burning DVD
*/
typedef HWEBOOL (HWEAPI *PFNHwe_IsDvdWriter)(const HWEHANDLE H);

// Added 2005-09-07 - In DLL version 2.0.5.236 or above

/*
  Global boolean to control the automatic tray ejection when the burning sequence has completed.
  Set to TRUE will prevent the tray from being opened after the burn finishes
*/
typedef HWEBOOL (HWEAPI *PFNHwe_GetDontAutoEject)(const HWEHANDLE H);

typedef void (HWEAPI *PFNHwe_SetDontAutoEject)(const HWEHANDLE H, const  HWEBOOL Value);

// Added 2005-09-17 - In DLL version 2.0.6.237 or above **** DEPRECATED ****

/*
  Global boolean to control the burning type of DVD-R media.
  Set to TRUE will prefer SAO writing, FALSE will prefer Packet writing.
  Default is FALSE
*/

/**** DEPRECATED **** use Hwe_GetDVDRWritingModeAffinity instead ******/
typedef  HWEBOOL (HWEAPI *PFNHwe_GetPreferDVDRSao)(const HWEHANDLE H);

/**** DEPRECATED **** use Hwe_SetDVDRWritingModeAffinity instead ******/
typedef void (HWEAPI *PFNHwe_SetPreferDVDRSao)(const HWEHANDLE H, const  HWEBOOL Value);

// Added 2005-09-19 - in DLL version 2.0.7.239 or above

/*
	given a size of files to burn (in bytes), return the list of suitable media (that have enough capacity
	to store all the files + the underlying filesystem)

	PARAMETERS
	FileSize (In) = the size in bytes of the data to write on the disc
	szList (In) = Pointer to the string to fill (can be NULL)
	dwSize (In) = Size of the string to fill (can be 0)

	RETURN
	the number of bytes required for the string (not counting the trailing '\0')

	NOTE: This function assume a size of 1 MB. will be reserved for the need of file system creation. This is OK for 99.9% of the time,
	however filesystem will take more than this value if there is a large number of files (more than 300 for video dvd, and more than 1000 for data cd/dvd).

*/

typedef int (HWEAPI *PFNHwe_GetSuitableMediaList)(const HWEHANDLE H, __int64 FileSize, char *szList, unsigned int dwSize);


// Added 2005-10-12 - in Dll version 2.0.10.247 or above

/*
	given a DOS drive letter, return if this drive has DMA transfert mode enabled

	Possible return values:
	 1: DMA is enabled for this drive
	 0: DMA is disabled for this drive
	-1: Drive is not connected to IDE,
	    so DMA can be considered as enabled
	-2: Passed drive letter doesn't match a CD/DVD device
	-3: Access layer is not in DRIVER mode, so this information can't be gathered
	-4: The user privileges aren't enough to access this information

*/

typedef int (HWEAPI *PFNHwe_DmaEnabled)(const HWEHANDLE H, char DriveLetter);

// Added 2006-07-28 - In Dll version 2.0.22.272 or above

/*
  Get/Set custom layer break values for DL DVD+R media. Set to 0 (Zero) to let the burning SDK decide.

  From this DLL version, layer break determination is correctly implemented either for ISO or normal DVD.
  In precedent build, layer break was decided always at 1/2 the size of the data to write.

*/
typedef int (HWEAPI *PFNHwe_GetLayerBreak)(const HWEHANDLE H);


typedef void (HWEAPI *PFNHwe_SetLayerBreak)(const HWEHANDLE H, int Value);

// Added 2007-01-29 - In DLL version 2.1.0.294 or above

/*
 DMA details
 return a string containing the DMA current status of the drive
 all the possible DMA values are:
  "Not Applicable to this bus type" : DMA setting is for IDE (ATAPI) drives only
  "Unspecified Mode" : Impossible to determine the DMA mode (shall never happen)
  "PIO Mode" : Slow safe mode, burn/read operation will take lot of CPU time and max speed to x2
  "DMA Mode" : Mode DMA is on, but DMA type is not detected
  "DMA Mode 0"
  "DMA Mode 1"
  "DMA Mode 2"
  "Multiword DMA Mode 0"
  "Multiword DMA Mode 1"
  "Multiword DMA Mode 2"
  "Ultra DMA mode 0"
  "Ultra DMA mode 1"
  "Ultra DMA mode 2 (ATA33)"
  "Ultra DMA mode 3 (ATA50)"
  "Ultra DMA mode 4 (ATA66)"
  "Ultra DMA mode 5 (ATA100)"
  "Ultra DMA mode 6 (ATA133)"

 szName point to the string buffer (can be NULL)
 dwSize tell the length of the string (can be = 0)
 The return value is the number of bytes required for the string (not counting the trailing '\0')
*/

typedef int (HWEAPI *PFNHwe_DmaName)(const HWEHANDLE H, char DriveLetter, char* szName, int dwSize);


// Added 2007-08-31 - In DLL version 2.1.4.326 or above


/*
  Get/Set the writing mode strategy for DVD-R
  Here are the possible strategies values

	HWE_WRITE_AFFINITY_AUTOMATIC 0        // Let the engine detect automatically which writing mode is more suitable
                                              // The decision is done according to:
                                              // * If the source is mono-session, or if trying to burn a ISO image, DAO is tried first.
                                              // * If the source is multi-session or there is existing data on DVD, TAO is tried first.
                                              // * for each burning mode, there is a BLACKLIST of drives that doesn't support one or the other mode
                                              //   if such drive is encountered, the supported mode is forced
                                              // * if DAO has to be used with a multisession source, it'll turn multisession off while issuing a warning about it.
                                              //   if data already exist on a DVD-R in multisession, TAO mode is always forced, and DAO will not even be tried.

    // For all the following modes, If DAO is attempted and multimedia mode is on, it is turned off and a warning is issued
    HWE_WRITE_AFFINITY_FORCE_DAO 1        // Override all aforementionned logic to force DAO writing mode, if DAO fail to initialize, burning will fail
    HWE_WRITE_AFFINITY_FORCE_TAO 2        // Override all aforementionned logic to force TAO writing mode, if TAO fail to initialize, burning will fail
    HWE_WRITE_AFFINITY_PREFER_DAO 3       // prefer DAO writing mode, if DAO fail to initialize, log failure and try TAO
    HWE_WRITE_AFFINITY_PREFER_TAO 4       // prefer TAO writing mode, if TAO fail to initialize, log failure and try DAO

*/
typedef unsigned int (HWEAPI *PFNHwe_GetDVDRWritingModeAffinity) (const HWEHANDLE H);

typedef void (HWEAPI *PFNHwe_SetDVDRWritingModeAffinity) (const HWEHANDLE H, unsigned int Value);

// Added 2008-04-14 - In DLL version 2.1.8.340 or above

/* support for burning Blu-Ray Video :
	* UDF 2.5 filesystem used (readable from Windows Vista, or from 2K/XP with special driver)
	* Enforce the presence of a BDMV or BDAV folder into the root of the media
	* This function is asynchronous (will return immediately). progress, error or success are reported through the registered callback
	* Can be called safely from any thread context

*/
typedef void (HWEAPI *PFNHwe_StartBdvWriting)(const HWEHANDLE H,
										char *szDvdPath,
										char *szVolumeName);

// Added 2008-05-29 - In DLL version 2.1.9.343 of above

/* Support for ISO creation. Call SetIsoPath with a fully qualified file name to be written
  Call GetIsoPath to check that the file name is correct
  UNICODE SUPPORT: To pass ISO path with unicode characters, pass a string with the prefix "UTF8:",
  and the UTF-8 encoded path after.

  GetIsoPath return the string encoded that way (in UTF-8 and with "UTF8:" prefix)
  return the buffer size needed for the string (including trailing #0),
  szIsoPath and dwSize can be NULL (to obtain the size of the required buffer)
*/

typedef void (HWEAPI *PFNHwe_SetIsoPath)(const HWEHANDLE H, char *szIsoPath);

typedef unsigned int (HWEAPI *PFNHwe_GetIsoPath)(const HWEHANDLE H, char *szIsoPath, unsigned int dwSize);

// Added 2008-08-22 - In DLL version 2.1.12.351

/* Support for Media type check.
   IF the media type is checked, the burning will reject:
   * Any CD or Blu-Ray media if burning a Video DVD
   * Any CD,DVD media if burning a Blu-Ray video
*/

typedef  HWEBOOL (HWEAPI *PFNHwe_GetStrictMediaEnforcment)(const HWEHANDLE H);
typedef void (HWEAPI *PFNHwe_SetStrictMediaEnforcment)(const HWEHANDLE H, const  HWEBOOL Value);

//Added 2009-08-10 - In DLL version 4.0.0.193

/*
   Ability to enable/disable more verbosity on disc detection when the engine
   quickly check the media to find out if it can be used for writing operation.
   If set, detailled status information will be send through the WRO_LOG message.
   If not set, detailed status codes will be sent only through WRO_DISC_ACCEPTED or WRO_DISC_REJECTED messages)
*/

typedef  HWEBOOL (HWEAPI *PFNHwe_GetLogDiscDetectionStatus)(const HWEHANDLE H);
typedef void (HWEAPI *PFNHwe_SetLogDiscDetectionStatus)(const HWEHANDLE H, const  HWEBOOL Value);


// Added 2009-12-02 - in DLL version 4.0.7 or above
/*
	This function return all the possible writing speed for the selected drive with the inserted media, as a burning rate
	* a valid burn rate is defined by a nonzero value in the speedlist table.
	* burn rate is returned without units, and is dependant of the type of media
    see the mfc sample application for the usage of this function

*/
typedef  HWEBOOL (HWEAPI *PFNHwe_GetMediaWriteSpeeds)(const HWEHANDLE H, float *speedlist, int entrycount);

// Added 2011-05-31 - in DLL version 4.0.19.487 or above
// Updated 2019-01-18 - in DLL version 6.0.0.0 or above
/*
	This function install a callback to the data that will be passed to the burner. This allow inline patching of data before it is written, 
	and send command to the drive such as binding nonce for AACS encryption (so the resulting BD will be able to play Cinavia bloated content without shutting down the audio or stopping playback)

	The callback function provide to user 4 parameters:
	* user_opaque : optional user-provided arbitrary value
	* sector_index: the 0-based index of the base sector in which this data will be written - for CD writing and under some writing mode, this index can be NEGATIVE
	* data: data itself
	* data_bytesize: size of the written data. Usually represent 16 or 32 sectors (32 or 64 Kbytes blocks)
	* IVSOBurningAPISCSICommand interface: interface to send SCSI command to the drive


	To install the function, user can call PFNHwe_SetDataCallback providing the address of the callback function, and the optional user_opaque value.
	Return TRUE if the callback has been successfully installed.

	NOTE:
	* Only 1 callback at once (the last one) can be installed.
	* To remove the callback, pass NULL to data_cb
	* The callback can be installed/removed only when then engine is not in a burning operation, otherwise return FALSE
	* Callback function is called in arbitrary thread context (No GDI safe)
	* if an exception is raised during the call to this callback, the callback will not be called again.
	* as the callback is called synchronously in write thread, it is preferable to avoid taking too much processing time in it, 
	  otherwise it may degrade burning speed and quality
*/


#undef  INTERFACE
#define INTERFACE   IVSOBurningAPISCSICommand

DECLARE_INTERFACE_IID_(IVSOBurningAPISCSICommand, IUnknown, "69CE7C00-CC89-4ED5-868B-86E220469A9D")
{
public:
    // *** IUnknown methods ***
	virtual HRESULT __stdcall QueryInterface (REFIID riid, __out void **ppv);
    virtual ULONG __stdcall AddRef ();
    virtual ULONG __stdcall Release ();

    // *** IVSOBurningAPISCSICommand ***
    /*
	  SendSCSICommand - Send a SCSI command to the device

	  Parameters: 
	  CDB: pointer to a buffer containing SCSI CDB (6 to 16 bytes)
	  Send_Data: if TRUE (!=0) , passed buffer is SENT to the device, if FALSE (==0), passed buffer RECEIVE data from the drive. ignored if data=NULL
	  data: buffer to send / receive - can be NULL if no data is exchanged
	  data_bytesize: size of buffer (= 0 if data = NULL)
	  sense_buf: buffer of 18 bytes to receive sense data. Can be NULL

	  return: TRUE if command execute with success status, else FALSE and if sense_buf is provided, it is filled with sense data
	*/
	virtual HWEBOOL __stdcall SendSCSICommand(void *CDB, HWEBOOL Send_Data, unsigned char * data, int data_bytesize, unsigned char* sense_buf);

};

/* prototype of the callback */
typedef void (HWEAPI *PFNHwe_DataCallbackProc)(void *user_opaque, int sector_index, unsigned char *data, int data_bytesize, IVSOBurningAPISCSICommand *dev);

/* Installation of the data callback */
typedef HWEBOOL(HWEAPI *PFNHwe_SetDataCallback)(const HWEHANDLE H, PFNHwe_DataCallbackProc data_cb, void *user_opaque);


/* Added 2018-11-05 for DLL V6.0.0.0 or above */
/* Get version information about the SDK used, useful for log and bug tracking */
typedef HWEBOOL(HWEAPI *PFNHwe_GetSDKVersionInformation)(const HWEHANDLE Hwe, char* szInfo, unsigned int* pDwInfoLength);

/* Return TRUE if the inserted media in the currently selected device can be blanked (erased) */
typedef HWEBOOL(HWEAPI *PFNHwe_GetBlankAllowed)(const HWEHANDLE Hwe);

/* 
   Write arbitrary binary data to the media. 
   Client must develop an object exposing the IVSOBurningAPIDataReader interface, 
   and pass an instance as parameter in the function PFNHwe_StartBinaryWriting. 
   Once burning is finished (with or without error), the interface is released by the burn engine 

   To find a sample implementation of this interface is provided in the C++ MFC sample application
*/

#undef  INTERFACE
#define INTERFACE   IVSOBurningAPIDataReader

static const GUID IID_IVSOBurningAPIDataReader =
{ 0xC01F62C0, 0xA7CE, 0x4851, { 0xA0, 0x80, 0x00, 0x6A, 0x8B, 0x1A, 0x46, 0x29} };

DECLARE_INTERFACE_IID_(IVSOBurningAPIDataReader, IUnknown, "C01F62C0-A7CE-4851-A080-006A8B1A4629")
{
public:
	// *** IUnknown methods ***
	virtual HRESULT __stdcall QueryInterface(REFIID riid, __out void **ppv);
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();

	// *** IVSOBurningAPIDataReader ***
	/*
	  GetTotalSectorCount - Get the size of the data to be written, in number of sectors. this is called once when initializing writer

	  Parameters:
	  none

	  return: The total number of sectors to be written to the device. Each sector is 2048 Bytes
	*/
	virtual ULONG __stdcall GetTotalSectorCount();

	/*
	  readData - read binary data 

	  Parameters: 
	    pData - pointer to data buffer
		sector_count - number of sectors 
		sector_index - current index of sector to write
		last - if set to TRUE, the read process will stop considering all the data has been received

	  return: none
	*/
	virtual void __stdcall readData(void * pData, int sector_count,	__int64 sector_index, HWEBOOL *last);					
};
/* Start the burn sequence with the Data reader interface */
typedef void(HWEAPI *PFNHwe_StartBinaryWriting)(const HWEHANDLE Hwe, IVSOBurningAPIDataReader *ReadStream);

/* 
	Burn progress interface. It allow user to get in any thread context some information about the writing process.
*/
enum EBurnOp {  burn_idle,                   // burn not started yet
				burn_prepare,                // preparing data structures
				burn_init_device,            // initializing device for writing
				burn_write,                  // writing data
				burn_finishing,              // terminating write
				burn_success,                // burn completed successfully
				burn_error                   // burn completed with error
};

#undef  INTERFACE
#define INTERFACE   IVSOBurningSDKProgress

DECLARE_INTERFACE_IID_(IVSOBurningSDKProgress, IUnknown, "C01F62C0-A7CE-4851-A080-006A8B1A4629")
{
public:
	// *** IUnknown methods ***
	virtual HRESULT __stdcall QueryInterface(REFIID riid, __out void **ppv);
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();

	/* Return the curent write operation (see EBurnOp enum) */
	virtual EBurnOp __stdcall GetCurrentOperation(); 

	/* Return the number of data sectors (2KB) to be written to the media */
	virtual unsigned int __stdcall GetTotalDataToWrite(); 

	/* Return the number of sectors that are written at the time of the call */
	virtual int __stdcall GetDataWritten(); 

	/* Return the actual size and occupation in number of sectors of the device cache. This function should not be called too frequently as it get its information from the writer */
	virtual HWEBOOL __stdcall GetDeviceCacheOccupation(unsigned int *CacheSize, unsigned int *Occupation); 

	/* Return a table containing the relative time - expressed in microseconds - of when the burner have accepted a given chunk of data to be burned.
       This allow one to display in realtime very accurate burning speed statistics. 

	   Each entry in the table contains a int64_t value representing the time in S since the first data chunk (block) of sectors was submitted to the drive.

	   Parameters: 
		blockSize		= Number of sector per data block, must be a multiple of 32 sectors
		blockOffset		= Index (zero based) of 1st block to be copied into the TimeTable
		nbBlocks		= number of allocated entries in the timing table (int64_t entry, 8 bytes each)
		TimeTable	    = Pointer to the table data. Can be NULL

	  Return value:
	    The actual number of blocks that have been sent to the writer. if < 0 it's an error code. 

	*/
	virtual int __stdcall GetWriteTimings(
		unsigned int blockSize,           
		unsigned int blockOffset,         
		unsigned int nbBlocks,        
		__int64 * TimeTable  
	);                      
	/* 
		Return the instant data speed, in kilobytes per second. 
		Parameters:
		  CurrentSector: The amount of data in sectors (2KB) that has been sent to the drive.
		  Avg_sec: if > 0, it is the size of the average window, in seconds (so it an instantaneous speed). 
		  If = 0 the speed is provided from the start (so it's the average speed).
		  WARNING: the lower avg_sec is, the bigger the internal cache of burner may affect the result. 
		  8-10 Sec is a reasonable value to get a good instant speed.
		  
		Return value: 
		  the burning speed in KB/S
		  0 if avg_sec is not elapsed yet since the 1st data sent to the drive.

	*/
	virtual float __stdcall GetCurrentDataSpeedKBPS(int *CurrentSector, float Avg_sec);
};

/* Function to obtain the burning progress interface. 
   It's a good time to call this before any Hwe_Start** function
   Once the burn sequence has been completed, it is released from the burning engine. so for another burn sequence, a new interface must be obtained

   Return value: 
     TRUE if success. Otherwise FALSE and the interface will not be provided
*/
typedef HWEBOOL (HWEAPI *PFNHwe_GetProgressInterface)(const HWEHANDLE Hwe, IVSOBurningSDKProgress **progress);





#endif
